<?php
	/*
	* 2018 - VEGA Informatique
	*
	* NOTICE OF LICENSE
	*
	* This source file is subject to the Open Software License (OSL 3.0)
	* that is bundled with this package in the file LICENSE.txt.
	* It is also available through the world-wide-web at this URL:
	* http://opensource.org/licenses/osl-3.0.php
	*
	* DISCLAIMER
	*
	* Do not edit or add to this file if you wish to upgrade PolarisLink to newer
	* versions in the future. 
	*
	*  @author VEGA Informatique <contact@vega-info.fr>
	*  @copyright  2018 VEGA Informatique
	*  @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
	*/

	if (!defined('_PS_VERSION_'))
		exit;
				
	require_once( _PS_ROOT_DIR_ . "/modules/polarislink/classes/PolarisLinkAPI.php");
	require_once( _PS_ROOT_DIR_ . "/modules/polarislink/classes/PolarisLinkJobManager.php");	
		
	/*
	 * exécution des travaux
	 *
	 */
	class PolarisLinkAPI_runModuleFrontController extends PolarisLinkAPI
	{
		private $Exit = [];

		public function __construct()
		{			
			$this->AuthByTokenAllowed = true;
			parent::__construct();
		}
		
		private function doJobs($links)
		{			
			foreach ($links as $link)
			{
				$startTime = microtime(true);

				$jobsManager = new PolarisLinkJobManager($link);
				if (isset($_REQUEST['debug']))
					$jobsManager->DebugMode = true;
				$jobsManager->run();
				
				$endTime = microtime(true);
				if (isset($_REQUEST['debug']))
					$this->Exit[] = sprintf("%s's jobs processed in %.2f\" with cache %s", 
						$link->LinkName,
						$endTime - $startTime, 
						$jobsManager->isUsingRefCache() ? "ON" : "OFF");
			}
		}		
		
		protected function runAPI()
		{
			// Surtout plus de cache !!!
			Db::getInstance()->disableCache();

			// Appel métriques ?
			$this->module->sendMetrics();			

			if (isset($_REQUEST['debug']))
			{
				@ini_set('display_errors', '1');
				@ini_set('html_errors', '0');
				//@ini_set('error_log', 'xxx.log');
				
				@error_reporting(E_ALL | E_STRICT);				
				
				// Au revoir les interceptions Prestashop !!!
				set_error_handler(NULL);
				
				header("Content-Type: text/plain; charset=utf-8");
			}			

			$sites = $this->module->Config;
			
			if (Tools::getValue('wait') == 1)
			{				
				$this->doJobs($sites);
				$this->answerJSON($this->Exit);
			}
			else
			{
				if (!Configuration::get("POLARISLINK_CRON_DATAUPDATE") || isset($_REQUEST['debug']))
				{
					$this->AnswerAndContinueOffline([]);
										
					// On traite en arrière plan après avoir répondu
					ob_start();
					$this->doJobs($sites);
					ob_end_clean();
				}
				else
				{
					// Ne rien faire !
					$this->answerJSON(array());
				}
			}			
		}
	}
 